--- coreutils-9.5/tests/df/no-mtab-status.sh.orig
+++ coreutils-9.5/tests/df/no-mtab-status.sh
@@ -35,9 +35,13 @@
 #define _GNU_SOURCE
 #include <stdio.h>
 #include <errno.h>
-#include <mntent.h>
 #include <string.h>
 #include <dlfcn.h>
+#ifdef __sun
+#include <sys/mnttab.h>
+#else
+#include <mntent.h>
+#endif
 
 #define STREQ(a, b) (strcmp (a, b) == 0)
 
@@ -69,7 +73,11 @@
     return fopen_func(path, mode);
 }
 
+#ifdef __sun
+int getmntent (FILE *fp, struct mnttab *mp)
+#else
 struct mntent *getmntent (FILE *fp)
+#end
 {
   /* Prove that LD_PRELOAD works. */
   static int done = 0;
@@ -80,7 +88,11 @@
     }
   /* Now simulate the failure. */
   errno = ENOENT;
+#ifdef __sun
+  return -1;
+#else
   return NULL;
+#endif
 }
 EOF
 
